%
% Agucamento usando Laplaciano
%
% Moacir Ponti Jr (ICMC/USP) 2012-1
% 
function B = agucamento(A,c)

    % recupera o tamanho da imagem
    [N,M] = size(A);

    % filtro laplaciano
    W = [0 1 0; 1 c 1; 0 1 0 ];

    % aplica laplaciano
    L = filter2(W,A);

    % soma
    S = double(A) + (-1.*double(L));

    % ajusta valores para o intervalo [0 255]
    B = mat2gray(S);
