%Copyright (C) 2005  Berge-Gladel

%This program is free software; you can redistribute it and/or
%modify it under the terms of the GNU General Public License
%as published by the Free Software Foundation; either version 2
%of the License, or (at your option) any later version.

%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.

function nouvmat1 = rgb2ycbcr(in)

%
%   Example 
%   -------
%   mat = rgb2ycbcr('2cv.jpg')
%   mat is the equivalent image of '2cv.jpg' in the YCBCR color space.


	[img,map] = imread(in);
	
	s = size(img) % on recupere la taille de l'image pour differencier une image d'une colormap

		
		matrice(:,:,:) = colormap(map) ; 
		% on multiplie la matrice par 255 pour avoir des valeurs entre 0 et 255 au lieu de entre 0 et 1
		matrice = matrice * 255;
		m=size(matrice);

		nbligmat = m(1);
		nbcolmat = m(2);

		nouvmat1 = ones(nbligmat,nbcolmat);

		
		for i = 1 : nbligmat
			% Y = 0.299*R + 0.587*G + 0.114*B
			nouvmat1(i,1) = 0.299*matrice(i,1,:) + 0.587*matrice(i,2,:) + 0.114*matrice(i,3,:);
			% Cb = - 0.1687*R - 0.3313*G + 0.5*B + 128;
			nouvmat1(i,2) = - 0.1687*matrice(i,1,:) - 0.3313*matrice(i,2,:) + 0.5*matrice(i,3,:) + 128;
			% Cr = 0.5*R - 0.4187*g - 0.0813*B + 128;
			nouvmat1(i,3) = 0.5*matrice(i,1,:) - 0.4187*matrice(i,2,:) - 0.0813*matrice(i,3,:) + 128;
		end
		
		
    	
	
	
	% on divise par 255 car on avait multiplie par 255 au prealable.
   nouvmat1 = nouvmat1 / 255; % la matrice des compo en y crcb
   
 endfunction
